import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.*;
public class SimpleCipher_AlgParams {
	public static void main(String[] args) throws Exception {
		// Key
		byte[] aKeyBytes = "12345678".getBytes();
    DESKeySpec desKeySpec = new DESKeySpec(aKeyBytes);
    SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
    SecretKey key = keyFactory.generateSecret(desKeySpec);	
    
    // IV
    byte[] iv = "00000000".getBytes();
	  IvParameterSpec ivParams = new IvParameterSpec(iv);

		// 
		byte[] plaintext = "Simple Cipher Test".getBytes("UTF8");
		for(int i = 0; i<plaintext.length; i++)
			System.out.print(Integer.toHexString(plaintext[i]&0xFF) + " ");
		System.out.println();
		
		// ȣ  ʱȭ
		Cipher cipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
		cipher.init(Cipher.ENCRYPT_MODE, key, ivParams);

		// ȣ   
		byte[] ciphertext = cipher.doFinal(plaintext);
		for(int i = 0; i<ciphertext.length; i++)
			System.out.print(Integer.toHexString(ciphertext[i]&0xFF) + " ");
		System.out.println();
		
		// ȣ  ٽ ʱȭ
		cipher.init(Cipher.DECRYPT_MODE, key, ivParams);
		// ȣȭ   
		byte[] decryptedtext = cipher.doFinal(ciphertext);
		
		for(int i = 0; i<decryptedtext.length; i++)
			System.out.print(Integer.toHexString(decryptedtext[i]&0xFF) + " ");
		System.out.println();
		
		String output = new String(decryptedtext, "UTF8");
		System.out.println(output);
	}
}
