import java.io.*;
import java.security.*;
import java.security.spec.*;

public class SimpleGenKeyPair {
	public static void main(String[] args) throws Exception {	
		// Ű 
		System.out.println("RSA Ű մϴ.");
		KeyPairGenerator kpg = KeyPairGenerator.getInstance("RSA");
		kpg.initialize(1024);
		KeyPair rsaKeyPair = kpg.generateKeyPair();		
		
		byte[] rsaPubBytes = rsaKeyPair.getPublic().getEncoded();
		byte[] rsaPrvBytes = rsaKeyPair.getPrivate().getEncoded();
		
		// Ű 
		System.out.println("RSA Ű մϴ.");
		X509EncodedKeySpec x509KeySpec = new X509EncodedKeySpec(rsaPubBytes);
		DataOutputStream output = new DataOutputStream(new FileOutputStream("myRsa.pubkey"));
		output.write(x509KeySpec.getEncoded());
		output.close();
		
		PKCS8EncodedKeySpec pkcs8KeySpec = new PKCS8EncodedKeySpec(rsaPrvBytes);
		output = new DataOutputStream(new FileOutputStream("myRsa.prvkey"));
		output.write(pkcs8KeySpec.getEncoded());
		output.close();
	}
}