import java.io.*;
import org.bouncycastle.x509.*;
import org.bouncycastle.asn1.x509.*;
import java.math.*;
import java.util.*;
import java.security.*;
import java.security.cert.*;
import java.security.spec.*;

public class x509CertGen_an {

  
 public static void main(String[] args)throws Exception{
 
try{
//Ű о
FileInputStream fis =new FileInputStream("myRsa.pubkey");//x509ڵ
byte[] pub = new byte[fis.available()];
fis.read(pub);
fis.close();
X509EncodedKeySpec x509kye = new X509EncodedKeySpec(pub);
KeyFactory keyFac =KeyFactory.getInstance("RSA");
PublicKey pubKey =keyFac.generatePublic(x509kye);

//Ű о
fis = new FileInputStream("myRsa.prvkey");//PKCS8 ڵѴ
byte[] prv =new byte[fis.available()];
fis.read(prv);
fis.close();
PKCS8EncodedKeySpec pkcs8Key = new PKCS8EncodedKeySpec(prv);
keyFac =KeyFactory.getInstance("RSA");
PrivateKey prvKey = keyFac.generatePrivate(pkcs8Key);

BigInteger  sn        = new BigInteger("12345678");
X509Name issuer   = new X509Name(true,"CN=KoreaIT CA, OU=Korea IT, C=KR");
X509Name subject = new X509Name(true,"CN=KoreaIT CA, OU=Korea IT, C=KR");
Date notAfter    = new Date(107, 9, 2, 0, 0);
Date notBefore = new Date(106, 9, 2, 0, 0);


X509V1CertificateGenerator  x509v1CertGen = new X509V1CertificateGenerator ();
x509v1CertGen.setIssuerDN(issuer);
x509v1CertGen.setSubjectDN(subject);
x509v1CertGen.setNotAfter(notAfter);
x509v1CertGen.setNotBefore(notBefore);
x509v1CertGen.setPublicKey(pubKey);
x509v1CertGen.setSerialNumber(sn);
x509v1CertGen.setSignatureAlgorithm("SHA1WithRSA");

 X509Certificate x509Cert = 
      x509v1CertGen.generateX509Certificate(prvKey);
    FileOutputStream fos = new FileOutputStream("myRsa2.cer");
 fos.write(x509Cert.getEncoded());
 fos.flush();
 fos.close();

 System.out.println("myRsa.cer   ϴ");
}catch(Exception e){
	System.out.println(e.toString());
}
}
}
