import java.io.*;
import java.util.*;
import java.security.*;
import java.security.spec.*;
import javax.crypto.*;

public class SimpleRSASignature {
	public static void main(String[] args) throws Exception {	
		// Ű 
		System.out.println("RSA Ű ɴϴ.");
		DataInputStream input = new DataInputStream(new FileInputStream("myRsa.pubkey"));
		byte[] rsaPubBytes = new byte[input.available()];
		input.read(rsaPubBytes);
		input.close();
		
		input = new DataInputStream(new FileInputStream("myRsa.prvkey"));
		byte[] rsaPrvBytes = new byte[input.available()];
		input.read(rsaPrvBytes);
		input.close();

		X509EncodedKeySpec  x509KeySpec  = new X509EncodedKeySpec(rsaPubBytes);
		PKCS8EncodedKeySpec pkcs8KeySpec = new PKCS8EncodedKeySpec(rsaPrvBytes);
		
		KeyFactory kf = KeyFactory.getInstance("RSA");
 		PublicKey rsaPublicKey = kf.generatePublic(x509KeySpec);
 		PrivateKey rsaPrivateKey = kf.generatePrivate(pkcs8KeySpec);
 		byte[] data = "signature test...".getBytes();
			
		//   
		System.out.println(" մϴ.");
		Signature s = Signature.getInstance("SHA1withRSA");
		s.initSign(rsaPrivateKey);
		s.update(data);
		byte[] sign = s.sign();

		//   
		for(int i = 0; i<sign.length; i++) 
			System.out.print(sign[i] + " ");
		System.out.println();
		
		System.out.println(" մϴ.");
		s.initVerify(rsaPublicKey);
		s.update(data);
		s.verify(sign);
	}
}